<template>
    <div class="delivery-container">
            <h2>ДОСТАВКА</h2>      
            <br><!-- -->    
            <delivery-param @change='changeDeliveryType(arguments[0])' />
            <br v-if='getDeliveryType === 2'>
            <delivery-source-param v-if='getDeliveryType === 2' @change='changeDeliverySource(arguments[0])' />
            <br>                 
            <p v-if='getDeliveryType !== 2 && !this.$store.state.validStreet || !this.$store.state.validBuilding' class='validation-text'>Нам важно знать, куда доставить пиццу</p>         
            <p v-if='getDeliveryType !== 0 && !this.$store.state.validTime' class='validation-text'>Нам важно знать, к какому времени пицца должна быть готова</p>         
            <input 
                :class='this.$store.state.validStreet ? "" : "invalid"' id="input-street" 
                type="text" 
                placeholder="Улица"                 
                autocomplete="off" 
                :value="getStreet"
                @input="inputStreet"
                @keyup.enter="fetchLatLng"
                v-if='getDeliveryType !== 2'
            />
            <br v-if='getDeliveryType !== 2'>       
            <input 
                :class='this.$store.state.validBuilding ? "small" : " small invalid"' 
                type="text" 
                placeholder="Дом"                 
                autocomplete="off" 
                :value='getBuilding' 
                @input="inputBuilding"
                @keyup.enter="fetchLatLng"
                v-if='getDeliveryType !== 2'
            /> 
            <input
                class="small"
                type="text" 
                placeholder="Подъезд"                 
                autocomplete="off" 
                :value='getEntrance' 
                @input="inputEntrance"      
                v-if='getDeliveryType !== 2'          
            />
            <br v-if='getDeliveryType !== 2'>            
            <input
                class="small"
                type="text" 
                placeholder="Этаж"                 
                autocomplete="off" 
                :value='getFloor' 
                @input="inputFloor"           
                v-if='getDeliveryType !== 2'     
            /> 
            <input
                class="small"
                type="text" 
                placeholder="Кв./оф."                 
                autocomplete="off" 
                :value='getRoom' 
                @input="inputRoom"    
                v-if='getDeliveryType !== 2'            
            />
            <br v-if='getDeliveryType !== 2'>             
            <input
                id="input-time"
                :class='this.$store.state.validTime ? "time" : " time invalid"'                 
                type="time" 
                placeholder="Время"                 
                autocomplete="off" 
                :value='getTime' 
                @input="inputTime"                
                required="required" 
                v-if='getDeliveryType !== 0'
            /> 
            <br>            
            <input id="call-require" class="checkbox" type="checkbox"  
                @click="inputCallRequire"
                v-if='getOrderItems.length > 0'
            />
            <label for="call-require" v-if='getOrderItems.length > 0'>Требуется звонок</label>
            <br>
            <br>            
            <gmap-map 
                ref="map"
                class='map' 
                :center='{ lat: 55.655826, lng: 37.6172999 }' 
                :zoom='10' 
                :options='{gestureHandling: "none"}'
            > 
                <gmap-marker :position="getLatLng" />
                <gmap-polygon 
                    :key="polygon.id"
                    v-for="polygon in getPolygons"
                    :path="polygon.path"
                    :options="{
                        strokeWeight: 1,
                        strokeColor: '#f0712c',
                        fillColor: '#f0712c',
                    }" 
                />
            </gmap-map>

    </div>
</template>
<script>
import { mapGetters, mapMutations, mapActions } from 'vuex';
import DeliveryParam from './DeliveryParam';
import DeliverySourceParam from './DeliverySourceParam'
import { mask } from 'vue-the-mask'
export default {
    directives: {
        mask
    },
    components: {
        DeliveryParam,
        DeliverySourceParam,
    },
    methods: {        
        ...mapMutations([
            'updateStreet',
            'updateBuilding',
            'updateTime',
            'updateEntrance',
            'updateFloor',
            'updateRoom',
            'changeDeliveryType',
            'changeDeliverySource',
            'hideDelivery',
        ]),                
        ...mapActions([
            'fetchLatLng',
        ]),
        inputStreet(event) {
            this.$store.commit('updateStreet', { value: event.target.value, map: this.$refs.map.$mapObject });            
        },
        inputBuilding(event) {
            this.$store.commit('updateBuilding', { value: event.target.value, map: this.$refs.map.$mapObject });
        },
        inputEntrance(event) {
            this.$store.commit('updateEntrance', { value: event.target.value });            
        },
        inputFloor(event) {
            this.$store.commit('updateFloor', { value: event.target.value });            
        },
        inputRoom(event) {
            this.$store.commit('updateRoom', { value: event.target.value });            
        },
        inputTime(event) {
            this.$store.commit('updateTime', {value: event.target.value });
        },
        inputCallRequire(event) {
            this.$store.commit('updateCallRequire');
        }
    },
    computed: {
        ...mapGetters([
            'getStreet',
            'getBuilding',
            'getEntrance',
            'getFloor',
            'getRoom',
            'getTime',
            'getLatLng',            
            'getInPolygonsStatus',
            'showDelivery',
            'getPolygonWorktime',
            'getPolygons',
            'getDeliveryType',
            'getOrderItems',
        ]),
        kladrRequest() {
             return `http://kladr-api.ru/api.php?contentType=street&cityId=7700000100000&limit=30&query=`;
        },                
    }
}
</script>
<style scoped>   
    /* .map {
        width: 100%;        
        height: 300px;
    } */
    p {
        margin-bottom: 10px;
    }
    .validation-text {
        color: red;        
    } 
    .success-text {
        color: green;        
    } 
    .delivery-container {
        text-align: left;                        
    }        
    #input-street {
        min-width: 280px;        
    }
    input[type='text'], input[type='time'] {        
        font-size: 16px;
        outline: none;
        border-radius: 10px;
        padding: 10px;
        border: 1px solid #ccc;
        margin-bottom: 20px;
        width: 61%;
        box-shadow: inset 0px 0px 0px 0px red;
    }
    input[type='text']:focus, input[type='time']:focus {
        outline: none;
        border: 1px solid #f0712c;        
    }
    input[type='text'].invalid, input[type='time'].invalid {
        border: 1px solid red;
    }
    input[type='text'].small, input[type='time'].small {        
        width: 120px;
        margin-right: 8px;
    }
    input[type='time'].time {
        width: 120px;        
    }
    input[type=time]::-webkit-inner-spin-button {
        -webkit-appearance: none;
        display: none;
    }
    .button {
        border: none;
        border-radius: 10px;
        background-color: #f0712c;
        color: white;                
        padding: 10px;
        margin-bottom: 20px;
        width: 39%;
        min-width: 150px;
        transition: all 0.1s ease;
    }
    .button:hover {
        background-color: #de601b;
    }

    .checkbox {
    position: absolute;
    z-index: -1;
    opacity: 0;
    margin: 10px 0 0 20px;
    }
    .checkbox + label {
    position: relative;
    padding: 0 0 0 60px;
    cursor: pointer;    
    }
    .checkbox + label:before {
    content: '';
    position: absolute;
    top: -4px;
    left: 0;
    width: 50px;
    height: 26px;
    border-radius: 13px;
    background: #CDD1DA;
    box-shadow: inset 0 2px 3px rgba(0,0,0,.2);
    transition: .2s;
    }
    .checkbox + label:after {
    content: '';
    position: absolute;
    top: -2px;
    left: 2px;
    width: 22px;
    height: 22px;
    border-radius: 10px;
    background: #FFF;
    box-shadow: 0 2px 5px rgba(0,0,0,.3);
    transition: .2s;
    }
    .checkbox:checked + label:before {
    background: #de601b;
    }
    .checkbox:checked + label:after {
    left: 26px;
    }


</style>

